-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}

local frameCount = 0
local castHeight = 610

local function onInit()
	electrics.values['rdr_alt'] = 0
end

local function onReset()
	onInit()
end

local function updateGFX(dt)
  frameCount = frameCount + 1
  if frameCount >= 8 then
    local pos = vec3(obj:getPosition())
    local castPos = pos - vec3(0, 0,  castHeight)
    obj:queueGameEngineLua("be:getObjectByID("..obj:getID().."):queueLuaCommand('radar_altimeter.callback('..be:castRay(vec3(" .. pos.x .. "," .. pos.y .. "," .. pos.z .. "):toPoint3F(), vec3(" .. castPos.x .. "," .. castPos.y .. "," .. castPos.z .. "):toPoint3F())..')')")
    
    frameCount = 0
  end
end

local function callback(height)
  if height == 0 then height = castHeight end --weird api design imo
  local heightFT = height * 3.28084
  
  if heightFT > 2000 then return end -- 2much
  
  if heightFT > 1000 then
    electrics.values['rdr_alt'] = 0.62135 + (((heightFT - 1000) / 500) * 0.0329277)
  elseif heightFT > 500 then
    electrics.values['rdr_alt'] = 0.58746666 + (((heightFT - 500) / 500) * 0.03321944)
  elseif heightFT > 200 then
    electrics.values['rdr_alt'] = 0.45663333 + (((heightFT - 200) / 100) * 0.044)
  else
    electrics.values['rdr_alt'] = (heightFT / 200) * 0.45663333
  end
end

-- public interface
M.onInit      = onInit
M.onReset     = onReset
M.updateGFX = updateGFX
M.callback = callback

return M